%Author: Tem messay

clear all; close all; clc
clf
ax = axes('XLim',[-10 10],'YLim',[-10 10],'ZLim',[0 10]);
%ax = axes('XLim',[-5 5],'YLim',[-5 5],'ZLim',[0 5]);
view(3); grid on; axis equal
xlabel('x'); ylabel('y'); zlabel('z');

[x y z] = cylinder(0.5);
h(1) = surface(x,y,z,'FaceColor','red');
[x y z] = cylinder(0.5);
h(2) = surface(x,y,z,'FaceColor','blue');
[x y z] = cylinder(0.5);
h(3) = surface(x,y,z,'FaceColor','blue');
[x y z] = cylinder(0.5);
h(4) = surface(x,y,z,'FaceColor','blue');
[x y z] = cylinder(0.5);
h(5) = surface(x,y,z,'FaceColor','red');
[x y z] = cylinder(0.5);
h(6) = surface(x,y,z,'FaceColor','blue');
[x y z] = cylinder([0.5 0]);
h(7) = surface(x,y,z,'FaceColor','blue');

t(1) = hgtransform('Parent',ax);
t(2) = hgtransform('Parent',t(1));
t(3) = hgtransform('Parent',t(2));
t(4) = hgtransform('Parent',t(3));
t(5) = hgtransform('Parent',t(4));
t(6) = hgtransform('Parent',t(5));
t(7) = hgtransform('Parent',t(6));


set(h(1),'Parent',t(1));
set(h(2),'Parent',t(2));
set(h(3),'Parent',t(3));
set(h(4),'Parent',t(4));
set(h(5),'Parent',t(5));
set(h(6),'Parent',t(6));
set(h(7),'Parent',t(7));

%set(h,'EdgeColor','none');


S = makehgtform('scale',[1 1 1]);
T = makehgtform('translate',[0 0 0]);
R = makehgtform('zrotate',0);
M1 = T*S*R;
set(t(1),'Matrix',M1);

S = makehgtform('scale',[1 1 2]);
T = makehgtform('translate',[0 0 1]);
set(t(2),'Matrix',T*S);

S = makehgtform('scale',[1 1 1/2]);
T = makehgtform('translate',[-.5 0 1]);
R = makehgtform('yrotate',pi/2);
set(t(3),'Matrix',T*S*R);

S = makehgtform('scale',[1 1 1]);
T = makehgtform('translate',[0 0 0.5]);
R = makehgtform('xrotate',pi/2);
set(t(4),'Matrix',T*S*R);

S = makehgtform('scale',[1 1 1]);
T = makehgtform('translate',[0 0 1]);
R = eye(4);
M2 = T*S*R;
set(t(5),'Matrix',M2);

S = makehgtform('scale',[1 2 1]);
T = makehgtform('translate',[0 0 0.5]);
R = makehgtform('xrotate',pi/2);
set(t(6),'Matrix',T*S*R);

S = makehgtform('scale',[1 1 1]);
T = makehgtform('translate',[0 0 1]);
set(t(7),'Matrix',T*S);

%3-D animation
enable = true

if enable
    pause(1)
    for joint_angle1 = 0:.05:2*pi
        R1 = makehgtform('zrotate',joint_angle1);
        set(t(1),'Matrix',M1*R1);
        pause(.025)
    end
    
    for joint_angle2 = 0:.05:2*pi
        R2 = makehgtform('zrotate',joint_angle2);
        set(t(5),'Matrix',M2*R2);
        pause(.025)
    end
    
    for joint_angle = 0:.05:2*pi
        R1 = makehgtform('zrotate',joint_angle);
        R2 = makehgtform('zrotate',joint_angle);
        set(t(1),'Matrix',M1*R1);
        set(t(5),'Matrix',M2*R2);
        pause(.05)
    end
    
    for joint_angle = 0:.05:2*pi
        R1 = makehgtform('zrotate',joint_angle);
        R2 = makehgtform('zrotate',-joint_angle);
        set(t(1),'Matrix',M1*R1);
        set(t(5),'Matrix',M2*R2);
        pause(.05)
    end
    
    for joint_angle = 0:.05:2*pi
        R1 = makehgtform('zrotate',-joint_angle);
        R2 = makehgtform('zrotate',joint_angle);
        set(t(1),'Matrix',M1*R1);
        set(t(5),'Matrix',M2*R2);
        pause(.05)
    end
end

%%

[x, y, z] = sphere(20);
%c(1) = surface(x,y,z,'FaceColor','none');
c(1) = surface(x,y,z,'FaceColor','green');
c(2) = surface(x,y,z,'FaceColor','black');

%tc(1) = hgtransform('Parent',ax);
tc(1) = hgtransform('Parent',ax);
tc(2) = hgtransform('Parent',tc(1));

%set(c(1),'Parent',tc(1));
set(c(1),'Parent',tc(1));
set(c(2),'Parent',tc(2));

set(c,'EdgeColor','none');

% T = makehgtform('translate',[0 0 0]);
% S = makehgtform('scale',1);
% MC1 = T*S;
% set(tc(1),'Matrix',MC1);

%T = makehgtform('translate',[-9 -1.5 3]);
T = makehgtform('translate',[0 0 0]);
S = makehgtform('scale',0.4);
%MC2 = T*S;
MC1 = T*S;
set(tc(1),'Matrix',MC1);

T = makehgtform('translate',[0 2 2]);
S = makehgtform('scale',1);
%MC3 = T*S;
MC2 = T*S;
set(tc(2),'Matrix',MC2);

%create dome representative of sky
[x, y, z] = sphere(50);
x = 9.*x/.4;
y = 9.*y/.4;
z = 9.*z/.4;
%set home position of celestial bodies by chopping dome at the
%initial/desired starting position of motion
z_indices = find(z <= 3/.4);
x(z_indices) = -9/.4;
y(z_indices) = -1.5/.4;
z(z_indices) = 3/.4;


%conversion to spherical coordinates
[thetas,phis,rs] = cart2sph( x, y, z);

%3-D animation
%view(0,90)
delta_col =1;
delta_row =2;

for row_idx = 29 : delta_row: length(x)-delta_row
    for col_idx = 1 : delta_col: length(x)-delta_col
% for col_idx = 1 : length(x)-delta_col
%     for row_idx = 31 : length(x)-delta_row

        
        %move celestial body according to x y z coordinates of dome
        T1 = makehgtform('translate',[x(row_idx+delta_row ,col_idx+delta_col)...
            y(row_idx+delta_row,col_idx+delta_col) z(row_idx+delta_row,col_idx+delta_col)]);
        %S1 = makehgtform('scale',1);
        set(tc(1),'Matrix',MC1*T1);
        
        %DELAY between vision and motors (to be altered for experiments
        %purposes
        pause(0.02)
        
        r = rs(row_idx+delta_row,col_idx+delta_col);
        theta = thetas(row_idx+delta_row,col_idx+delta_col)+2.9764
        phi = phis(row_idx+delta_row,col_idx+delta_col)-0.3177
        
        
        %move telescope accordingly
        R1 = makehgtform('zrotate',theta);
        R2 = makehgtform('zrotate',-phi);
        T_storage1 = M1*R1;
        T_storage2 = M2*R2;
        set(t(1),'Matrix',T_storage1);
        set(t(5),'Matrix',T_storage2);
        drawnow
        %Animation delay
        pause(0.1)
        
    end
end





